program check_catcorr
! Tests catcorr output file for given test input, link with cFITSIO
! Modified cgp 2012 Nov 4 to suit new default syserr=0.1
! use mySAS
use errorhandling
implicit none
character(len=*), parameter :: infile = "outfiles/P0005010301EPX000OBSMLI0000.fits"
character :: msg*50
integer :: unit, status, hdutype = 0, errors
!
status = 0
errors = 0
call ftgiou(unit, status)
call ftnopn(unit, infile, 0, status)
call ftmahd(unit, 2, hdutype, status)
if(hdutype /= 2) then
   errors = errors + 1
   write(*,*)'hdutype: expected value 2 found', hdutype
end if
call check('RAOFFSET', 2.7933199)
call check('DEOFFSET', 0.1053590)
call check('LIK_HOOD', 13.5400000)
call check('ROT_CORR', -2.01199e-2)
! call check('RAOFFSET', 2.80909e0)
! call check('DEOFFSET', 9.41410e-2)
! call check('LIK_HOOD', 13.78)
if(errors > 0) then
   write(msg,*)'check_catcorr found', errors, 'errors'
   call error('test_failed', msg)
end if

CONTAINS

subroutine check(keyword, value)
character(*), intent(in) :: keyword   ! FITS header keyword to check
real, intent(in)         :: value     ! Expected value
!
character(len=60) :: comment     ! actually not used
real :: keyval
!
call ftgkye(unit, keyword, keyval, comment, status)
if(abs(keyval - value) > 0.01 .or. status /= 0) then
   errors = errors + 1
   write(*,*) keyword, ' expected value', value, ' found ', keyval
end if
end subroutine check

end program check_catcorr
